package twitter;

import java.util.ArrayList;

public class BaseDeDatos {
    private static final ArrayList<Usuario> usuarios = new ArrayList<Usuario>();
    private static final ArrayList<Tweet> tweets = new ArrayList<Tweet>();
    private static final ArrayList<Reaccion> reacciones = new ArrayList<Reaccion>();

    public static void addUsuario(Usuario usuario){
        /*
        * Agrega un usuario si este no existe.
        * */
        if(usuario == null){
            return;
        }
        for(Usuario user: usuarios){
            if(user.getNombreUsuario().equals(usuario.getNombreUsuario())){
                System.out.println("ESTE NOMBRE DE USUARIO YA ESTA REGISTRADO");
                return;
            }
        }
        usuarios.add(usuario);
    }

    public static ArrayList<Usuario> getUsuarios(){
        /*
        * Obtiene todos los usuarios
         */
        return usuarios;
    }

    public static Usuario getUsuarioByUsername(String username){
        /*
        Obtiene un usuario por su username, si no existe retorna null
         */
        for(Usuario user: usuarios){
            if(user.getNombreUsuario().equals(username)) return user;
        }
        return null;
    }

    public static void addTweet(Tweet tweet){
        tweets.add(tweet);
    }

    public static ArrayList<Tweet> getTweets(){
        return tweets;
    }

    public static Tweet getTweetById(int id){
        return tweets.get(id);
    }

    public static void addReaccion(Reaccion reaccion){ reacciones.add(reaccion); }

    public static ArrayList<Reaccion> getReacciones(){ return reacciones; }
}
